/**
 * \file core/spoms/scenario.h
 * \date 18/02/2026
 * \author Aurélien Berthier, BENOIST Emile, TESSIER Dominique
 * \brief store alignment interpretations for precise alignment
 */


/*
 * PeptidOMS, Spectra to protein alignment tool
 * Copyright (C) 2026  Olivier Langella
 * <olivier.langella@cnrs.fr>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#pragma once

#include "aaposition.h"

namespace pappso
{
namespace spoms
{
class Scenario
{


  public:
  Scenario();


  Scenario(const Scenario &scenario);


  Scenario(int previous_line_number_in, int previous_column_number_in);


  Scenario &operator=(const Scenario &other);

  void update(const Scenario &scenario);


  void update(int previous_line_number_in, int previous_column_number_in);


  void update(int previous_line_number_in,
              int previous_column_number_in,
              const AAPosition &position_in);

  int getPreviousLineNumber() const;


  int getPreviousColumnNumber() const;

  const AAPosition &getPosition() const;


  private:
  int previous_line_number;
  int previous_column_number;
  AAPosition position;
};

} // namespace spoms
} // namespace pappso
